//+------------------------------------------------------------------+
//|                                     emission_Bands_and_MA_en.mq5 |
//|                                                 Copyright DC2008 |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "DC2008"
#property link      "http://www.mql5.com"
#property version   "1.00"
#property description "Emission of iBands and iMA indicators "
//---
input bool  H_line=true;   // flag to enable drawing of the horizontal lines
input bool  I_line=true;   // flag to enable drawing of the indicator's lines
//---
string      name;
double      draw_period=-240.0;  //Drawing depth period (in the past)
//---- indicator buffers
double      MA[];       // array for iMA indicator
double      BBH[];      // array for iBands indicator  - UPPER_BAND 
double      BBL[];      // array for iBands indicator - LOWER_BAND
double      BBM[];      // array for iBands indicator - BASE_LINE
datetime    T[];        // array for the time coordinates
//---- handles for indicators
int         MAHandle;   // iMA indicator handle
int         BBHandle;   // iBands indicator handle
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   MAHandle=iMA(Symbol(),0,21,0,MODE_EMA,PRICE_CLOSE);
   BBHandle=iBands(Symbol(),0,144,0,2,PRICE_CLOSE);
//---
   if(H_line) // Horizontal lines of iBands indicator 
     {
      //--- iBands - UPPER_BAND
      name="Hi";
      ObjectCreate(0,name,OBJ_HLINE,0,0,0);
      ObjectSetInteger(0,name,OBJPROP_COLOR,Red);
      ObjectSetInteger(0,name,OBJPROP_STYLE,STYLE_DOT);
      ObjectSetInteger(0,name,OBJPROP_WIDTH,1);
      //--- iBands - LOWER_BAND
      name="Lo";
      ObjectCreate(0,name,OBJ_HLINE,0,0,0);
      ObjectSetInteger(0,name,OBJPROP_COLOR,Blue);
      ObjectSetInteger(0,name,OBJPROP_STYLE,STYLE_DOT);
      ObjectSetInteger(0,name,OBJPROP_WIDTH,1);
      //--- iBands - BASE_LINE
      name="MIDI";
      ObjectCreate(0,name,OBJ_HLINE,0,0,0);
      ObjectSetInteger(0,name,OBJPROP_COLOR,DarkOrange);
      ObjectSetInteger(0,name,OBJPROP_STYLE,STYLE_DOT);
      ObjectSetInteger(0,name,OBJPROP_WIDTH,1);
     }
//---
   if(I_line) // Indicator lines
     {
      //--- iMA
      name="MA";
      ObjectCreate(0,name,OBJ_TREND,0,0,0,0);
      ObjectSetInteger(0,name,OBJPROP_COLOR,Red);
      ObjectSetInteger(0,name,OBJPROP_STYLE,STYLE_SOLID);
      ObjectSetInteger(0,name,OBJPROP_WIDTH,2);
      ObjectSetInteger(0,name,OBJPROP_RAY_RIGHT,1);
      ObjectSetInteger(0,name,OBJPROP_RAY_LEFT,1);
      //--- iBands - UPPER_BAND
      name="BH";
      ObjectCreate(0,name,OBJ_TREND,0,0,0,0);
      ObjectSetInteger(0,name,OBJPROP_COLOR,MediumSeaGreen);
      ObjectSetInteger(0,name,OBJPROP_STYLE,STYLE_SOLID);
      ObjectSetInteger(0,name,OBJPROP_WIDTH,1);
      ObjectSetInteger(0,name,OBJPROP_RAY_RIGHT,1);
      ObjectSetInteger(0,name,OBJPROP_RAY_LEFT,1);
      //--- iBands - LOWER_BAND
      name="BL";
      ObjectCreate(0,name,OBJ_TREND,0,0,0,0);
      ObjectSetInteger(0,name,OBJPROP_COLOR,MediumSeaGreen);
      ObjectSetInteger(0,name,OBJPROP_STYLE,STYLE_SOLID);
      ObjectSetInteger(0,name,OBJPROP_WIDTH,1);
      ObjectSetInteger(0,name,OBJPROP_RAY_RIGHT,1);
      ObjectSetInteger(0,name,OBJPROP_RAY_LEFT,1);
      //--- iBands - BASE_LINE
      name="BM";
      ObjectCreate(0,name,OBJ_TREND,0,0,0,0);
      ObjectSetInteger(0,name,OBJPROP_COLOR,MediumSeaGreen);
      ObjectSetInteger(0,name,OBJPROP_STYLE,STYLE_SOLID);
      ObjectSetInteger(0,name,OBJPROP_WIDTH,1);
      ObjectSetInteger(0,name,OBJPROP_RAY_RIGHT,1);
      ObjectSetInteger(0,name,OBJPROP_RAY_LEFT,1);
     }
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---

  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//--- filling the arrays with current values
   CopyBuffer(MAHandle,0,0,2,MA);
   ArraySetAsSeries(MA,true);
   CopyBuffer(BBHandle,0,0,2,BBM);
   ArraySetAsSeries(BBM,true);
   CopyBuffer(BBHandle,1,0,2,BBH);
   ArraySetAsSeries(BBH,true);
   CopyBuffer(BBHandle,2,0,2,BBL);
   ArraySetAsSeries(BBL,true);
   CopyTime(Symbol(),0,0,10,T);
   ArraySetAsSeries(T,true);

//--- Horizontal lines of iBands indicator (correction)
   if(H_line)
     {
      name="Hi";
      ObjectSetDouble(0,name,OBJPROP_PRICE,BBH[0]);
      name="Lo";
      ObjectSetDouble(0,name,OBJPROP_PRICE,BBL[0]);
      name="MIDI";
      ObjectSetDouble(0,name,OBJPROP_PRICE,BBM[0]);
     }
//--- Indicator's lines (correction)
   if(I_line)
     {
      name="MA";  //--- iMA
      ObjectSetInteger(0,name,OBJPROP_TIME,T[1]);
      ObjectSetDouble(0,name,OBJPROP_PRICE,MA[1]);
      ObjectSetInteger(0,name,OBJPROP_TIME,1,T[0]);
      ObjectSetDouble(0,name,OBJPROP_PRICE,1,MA[0]);
      name="BH";  //--- iBands - UPPER_BAND
      ObjectSetInteger(0,name,OBJPROP_TIME,T[1]);
      ObjectSetDouble(0,name,OBJPROP_PRICE,BBH[1]);
      ObjectSetInteger(0,name,OBJPROP_TIME,1,T[0]);
      ObjectSetDouble(0,name,OBJPROP_PRICE,1,BBH[0]);
      name="BL";  //--- iBands - LOWER_BAND
      ObjectSetInteger(0,name,OBJPROP_TIME,T[1]);
      ObjectSetDouble(0,name,OBJPROP_PRICE,BBL[1]);
      ObjectSetInteger(0,name,OBJPROP_TIME,1,T[0]);
      ObjectSetDouble(0,name,OBJPROP_PRICE,1,BBL[0]);
      name="BM";  //--- iBands - BASE_LINE
      ObjectSetInteger(0,name,OBJPROP_TIME,T[1]);
      ObjectSetDouble(0,name,OBJPROP_PRICE,BBM[1]);
      ObjectSetInteger(0,name,OBJPROP_TIME,1,T[0]);
      ObjectSetDouble(0,name,OBJPROP_PRICE,1,BBM[0]);
     }
//+------------------------------------------------------------------+
   int GTC=GetTickCount();
//+------------------------------------------------------------------+
   name="H"+(string)GTC;
   Draw_Point(name,BBH[1],BBH[0],MA[1],MA[0],170,178,Red,Red);
   name="L"+(string)GTC;
   Draw_Point(name,BBL[1],BBL[0],MA[1],MA[0],170,178,Blue,Blue);
   name="M"+(string)GTC;
   Draw_Point(name,BBM[1],BBM[0],MA[1],MA[0],170,178,Green,Green);
   name="B"+(string)GTC;
   Draw_Point(name,BBH[1],BBH[0],BBL[1],BBL[0],170,178,Magenta,Magenta);
//+------------------------------------------------------------------+
   ChartRedraw(0);
//+------------------------------------------------------------------+
//   Comment("");
   Comment("Emission  DC2008    Objects = ",ObjectsTotal(0,0,-1));
  }
//+------------------------------------------------------------------+
void Draw_Point(
                string   P_name,     // Object name (OBJ_ARROW)
                double   P_y1,       // Y-coordinate of the 1st line at the [1] bar
                double   P_y0,       // Y-coordinate of the 1st line at the [0] bar
                double   P_yy1,      // Y-coordinate of the 2nd line at the [1] bar 
                double   P_yy0,      // Y-coordinate of the 2nd line at the [0] bar
                char     P_code1,    // Char at the right side of the [0] bar
                char     P_code2,    // Char at the left side of the [0] bar
                color    P_color1,   // Color of point at the right side of the [0] bar
                color    P_color2    // Color of point at the left side of the [0] bar
                )
  {
   double   P,X;
   datetime P_time;
   if(MathAbs((P_yy0-P_yy1)-(P_y0-P_y1))>0)
     {
      P=P_y1+(P_y0-P_y1)*(P_y1-P_yy1)/((P_yy0-P_yy1)-(P_y0-P_y1));
      X=(P_y1-P_yy1)/((P_yy0-P_yy1)-(P_y0-P_y1));
      if(X>draw_period)
        {
         P_time=T[0]+(int)(X*PeriodSeconds());
         ObjectCreate(0,P_name,OBJ_ARROW,0,0,0);
         ObjectSetDouble(0,P_name,OBJPROP_PRICE,P);
         ObjectSetInteger(0,P_name,OBJPROP_TIME,P_time);
         ObjectSetInteger(0,P_name,OBJPROP_WIDTH,0);
         ObjectSetInteger(0,P_name,OBJPROP_ARROWCODE,P_code1);
         ObjectSetInteger(0,P_name,OBJPROP_COLOR,P_color1);
         if(X<0)
           {
            ObjectSetInteger(0,P_name,OBJPROP_ARROWCODE,P_code2);
            ObjectSetInteger(0,P_name,OBJPROP_COLOR,P_color2);
           }
        }
     }
  }
//+------------------------------------------------------------------+
